#include <FastLED.h>
#include <DS3231.h>
#include <Wire.h>
#include <time.h>
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h>
#endif
#define PIN 6
#define NUMPIXELS 64
#define NUM_LEDS 64      /* The amount of pixels/leds you have */
#define DATA_PIN 6       /* The pin your data line is connected to */
#define LED_TYPE WS2812B /* I assume you have WS2812B leds, if not just change it to whatever you have */
#define BRIGHTNESS 50   /* Control the brightness of your leds */
#define SATURATION 255   /* Control the saturation of your leds */

CRGB leds[NUM_LEDS];

DS3231 myRTC;
bool century = false;
bool h12Flag;
bool pmFlag;
byte alarmDay, alarmHour, alarmMinute, alarmSecond, alarmBits;
bool alarmDy, alarmH12Flag, alarmPmFlag;

int j = 0;


  int digits[][9] = {
    {},
    { 25, 28, 31 },
    { 9, 17, 25 },
    { 9, 11, 13, 14, 15 },
    { 24, 25, 26, 27 },
    { 8, 10, 12, 14 },
    { 0, 1, 2 },
    { 0, 3, 12, 14, 23 },
    { 3, 4, 5, 6, 7 },
    { 28, 29, 30, 31 },
    { 7, 15, 23 },
    { 18, 19, 20, 21, 22, 23 },
    { 16, 17, 18, 19, 20, 21, 22 },
    { 48, 50, 52, 53, 54, 60, 62, 63 },
    { 24, 25, 26, 27, 34, 36, 45, 47 },
    { 40, 41, 42, 43, 45, 46, 47 },
    { 0, 1, 2, 7, 15, 31, 47 },
    { 0, 20, 21, 22, 23, 43, 45, 46, 47 },
    { 3, 4, 5, 6, 7, 43, 45, 46, 47 },
    { 28, 29, 30, 31, 43, 45, 46, 47 },
    { 34, 35, 36, 37, 38, 39 },  // 20
    {},
    {},
    {},
    {},
    {},
    {},
    {},
    {},
    {},
    { 48, 50, 52, 53, 54, 55 },  // 30
    {},
    {},
    {},
    {},
    {},
    {},
    {},
    {},
    {},
    { 24, 25, 26, 27, 38, 39 },  // 40
    {},
    {},
    {},
    {},
    {},
    {},
    {},
    {},
    {},
    { 40, 41, 42, 43, 38, 39 },  // 50
    {},
    {},
    {},
    {},
    {},
    {},
    {},
    {},
    {},
  };



Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);
#define DELAYVAL 1000

void lightupmin(int x) {
  for (int y = 0; y < (sizeof(digits[x]) / sizeof(digits[x][0])); y++) {
    if (y == 0 || (y > 0 && digits[x][y] != 0)) {
      // pixels.setPixelColor(digits[x][y], pixels.Color(0, 150, 0));
      leds[digits[x][y]] = CRGB::Blue; 

    }
  }
}
void lightuphour(int x) {
  for (int y = 0; y < (sizeof(digits[x]) / sizeof(digits[x][0])); y++) {
    if (y == 0 || (y > 0 && digits[x][y] != 0)) {
      //pixels.setPixelColor(digits[x][y], pixels.Color(0, 0, 150));
      leds[digits[x][y]] =CRGB::White; 
    }
  }
}

void setup() {
#if defined(__AVR_ATtiny85__) && (F_CPU == 16000000)
  clock_prescale_set(clock_div_1);
#endif
  FastLED.addLeds<LED_TYPE, DATA_PIN>(leds, NUM_LEDS);

  pixels.begin();
  Wire.begin();

  Serial.begin(9600);
}

void loop() {
  // calculations here
  //  Serial.println(myRTC.getMinute(), DEC);
  //  Serial.println(myRTC.getHour(h12Flag, pmFlag), DEC);

  for (int i = 0; i < NUM_LEDS; i++) {
    leds[i] = CHSV(i - (j * 2), SATURATION, BRIGHTNESS); /* The higher the value 4 the less fade there is and vice versa */
  }
  ///FastLED.show();
  ///delay(25); /* Change this to your hearts desire, the lower the value the faster your colors move (and vice versa) */
  j = j+1;
  if (j == 255) {
    j = 0;
  }
  int min = myRTC.getMinute();
  int hour = myRTC.getHour(h12Flag, pmFlag);
  int tens = (min / 10) * 10;
  int ones = min % 10;
  int tensh = (hour / 10) * 10;
  int onesh = hour % 10;
  if (tens == 10) {
    lightupmin(ones + 10);
  } else if (tens == 0) {
    lightupmin(ones);
  } else {
    if (ones == 0) {
      lightupmin(tens);
    } else {
      lightupmin(tens);
      lightupmin(ones);
    }
  }
  if (tensh == 10) {
    lightuphour(onesh + 10);
  } else if (tensh == 0) {
    lightuphour(onesh);
  } else {
    if (onesh == 0) {
      lightuphour(tensh);
    } else {
      lightuphour(tensh);
      lightuphour(onesh);
    }
  }
  if (hour == min) {
    lightuphour(33);
  }
  Serial.println("-----------");
  FastLED.show();
  //pixels.show();
  // delay(0);
  //pixels.clear();
  FastLED.clear();
}